fun main(args: Array<String>) {
    println(getCoord1(289326 - 1).manhattan)
}

fun getCoord1(index: Int): Coord {
    var stepsLeft = index
    var stepSize = 1
    var stepDirection = 1

    var x = 0
    var y = 0

    while (true) {
        if (stepsLeft >= stepSize) {
            stepsLeft -= stepSize
            x += stepDirection * stepSize
        } else {
            x += stepDirection * stepsLeft
            break
        }
        if (stepsLeft >= stepSize) {
            stepsLeft -= stepSize
            y += stepDirection * stepSize
        } else {
            y += stepDirection * stepsLeft;
            break
        }

        stepSize++
        stepDirection *= -1
    }

    return Coord(x, y)
}

data class Coord(val x: Int, val y: Int) {
    val manhattan = Math.abs(x) + Math.abs(y)
}